module addnull_mod
  ! One Hundred Thousend flavors of the unfamiliar addnull routine
  
  interface addnull
    module procedure addnull_real
    module procedure addnull_realm2
    module procedure addnull_realm3
    module procedure addnull_real8
    module procedure addnull_real8m2
    module procedure addnull_real8m3
    module procedure addnull_cmplx
    module procedure addnull_cmplxm2
    module procedure addnull_cmplxm3
  end interface
  
  contains

  subroutine addnull_real   (add,x)
    logical,intent(in)    :: add
    real   ,intent(inout) ::     x(:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_realm2 (add,x)
    logical,intent(in)    :: add
    real   ,intent(inout) ::     x(:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_realm3 (add,x)
    logical,intent(in)    :: add
    real   ,intent(inout) ::     x(:,:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine



  subroutine addnull_real8   (add,x)
    logical,intent(in)    :: add
    real(8),intent(inout) ::     x(:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_real8m2 (add,x)
    logical,intent(in)    :: add
    real(8),intent(inout) ::     x(:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_real8m3 (add,x)
    logical,intent(in)    :: add
    real(8),intent(inout) ::     x(:,:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine



  subroutine addnull_cmplx   (add,x)
    logical,intent(in)    :: add
    complex,intent(inout) ::     x(:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_cmplxm2 (add,x)
    logical,intent(in)    :: add
    complex,intent(inout) ::     x(:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine

  subroutine addnull_cmplxm3 (add,x)
    logical,intent(in)    :: add
    complex,intent(inout) ::     x(:,:,:)

    if (.not. add) then;
      x = 0.
    end if

  end subroutine


end module
