module fftshift_mod
  ! Containing fftshifting functions
  
  use adjnull_mod
  
  implicit none
  
  ! In fftshift1d.inc
  interface fftshift1d_1_lop
   module procedure fftshift1d_real_real_1_1d
   module procedure fftshift1d_real_real_1_2d
   module procedure fftshift1d_real_real_1_3d
  end interface

  interface fftshift1d_2_lop
   module procedure fftshift1d_real_real_2_2d
   module procedure fftshift1d_real_real_2_3d
  end interface

  interface fftshift1d_3_lop
   module procedure fftshift1d_real_real_3_3d
  end interface

  
  ! In fftshift2d.inc
  interface fftshift2d_lop
   module procedure fftshift2d_real_real_12_2d
  end interface

  interface fftshift2d_12_lop
   module procedure fftshift2d_real_real_12_2d
   module procedure fftshift2d_real_real_12_3d
  end interface
  
  interface fftshift2d_23_lop
   module procedure fftshift2d_real_real_23_3d
  end interface
  
  interface fftshift2d_13_lop
   module procedure fftshift2d_real_real_13_3d
  end interface
  
  
  ! In fftshift3d.inc
  interface fftshift3d_lop
   module procedure fftshift3d_real_real_1d
   module procedure fftshift3d_real_real_2d
   module procedure fftshift3d_real_real_3d
  end interface


  contains
  

  include "fftshift1d.inc"
  include "fftshift2d.inc"
  include "fftshift3d.inc"

  
end module
